<template>
  <div
    class="ob-form-container"
    :class="[
      stateReadOnly && 'obForm-disabled',
      isLoading && '--loading'
    ]"
  >
    <div
      v-if="title || $slots.title"
      class="form-title"
    >
      <template v-if="$slots.title">
        <slot name="title" />
      </template>
      <template v-else>
        {{ title }}
      </template>
    </div>
    <div class="form-body">
      <slot />
    </div>
    <div
      v-if="isShowControls"
      class="form-footer"
    >
      <ObFormControls
        :dropdown-menu="dropdownMenu"
        :is-submit-disabled="submitBtnDisabled"
        :is-cancel-disabled="isCancelDisabled"
        :ok-text="okText"
        :cancel-text="cancelText"
        :is-read-only="stateReadOnly"
        :is-only-submit="isOnlySubmit"
        :is-error="isError"
        :is-active-element="isActiveElement"
        :btn-modal="btnModal"
        :data-qa="dataQa"
        @submit="$emit('submit', cloneDeep(formData))"
        @cancel="$emit('cancel', $event)"
        @on-change-active="$emit('change-active', $event)"
        @on-btn-modal="$emit('on-btn-modal')"
      />
    </div>
    <slot name="footer" />
    <transition name="fadeIn">
      <div
        v-if="isLoading"
        class="loading-block"
      >
        <ObLoader :size="60" />
      </div>
    </transition>
  </div>
</template>

<script>
import cloneDeep from 'clone-deep'
import { getValueFromPath } from '../../helpers/common'
import FORM_ERRORS from '../../resources/form_errors'
import ObFormControls from '../../obComponents/obForm/ObFormControls'
import ObLoader from '../../obComponents/obLoader'
import Vue from 'vue'
import Vuelidate from 'vuelidate'

Vue.use(Vuelidate)

export default {
  name: 'ObForm',
  components: {
    ObFormControls,
    ObLoader
  },
  props: {
    title: {
      type: String,
      default: null
    },
    formData: {
      type: Object,
      required: true
    },
    formModel: {
      type: Object,
      default: null
    },
    isReadOnly: {
      type: Boolean,
      default: false
    },
    isOnlySubmit: {
      type: Boolean,
      default: false
    },
    dropdownMenu: {
      type: Array,
      default: () => []
    },
    okText: {
      type: String,
      default: 'Сохранить'
    },
    cancelText: {
      type: String,
      default: 'Отмена'
    },
    isSubmitDisabled: {
      type: Boolean,
      default: undefined
    },
    isCancelDisabled: {
      type: Boolean,
      default: false
    },
    isShowControls: {
      type: Boolean,
      default: true
    },
    userAccess: {
      type: Object,
      default: null
    },
    isShowRequired: {
      type: Boolean,
      default: true
    },
    isOnPressEnterSubmit: {
      type: Boolean,
      default: false
    },
    isActiveElement: {
      type: Boolean,
      default: null
    },
    btnModal: {
      type: String,
      default: null
    },
    isLoading: {
      type: Boolean,
      default: false
    },
    isError: {
      type: Boolean,
      default: false
    },
    dataQa: {
      type: String
    },
    isNew: {
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      initFormData: {}
    }
  },
  computed: {
    isValid () {
      return this.$v && !this.$v.$invalid
    },
    submitBtnDisabled () {
      return this.isSubmitDisabled !== undefined
        ? this.isSubmitDisabled
        : this.isNew ? !this.isValid : !this.isValid || !this.formIsChanged
    },
    stateReadOnly () {
      return this.isReadOnly || (this.userAccess && !this.userAccess.UPDATE)
    },
    formIsChanged () {
      return JSON.stringify(this.formData) !== JSON.stringify(this.initFormData)
    },
    stateErrors () {
      if (this.isReadOnly || !this.formModel) return null
      let _this = this

      const compareRules = (RULES = [], RULES_VALIDATOR = {}, key) => {
        let errors = {}

        Object.keys(RULES)
          .forEach((rule) => {
            let error = RULES_VALIDATOR && RULES_VALIDATOR.$error && !RULES_VALIDATOR[rule] ? RULES[rule].error || FORM_ERRORS[rule] : false

            if (error) {
              if (!errors.mainError) {
                errors.mainError = {
                  key: rule,
                  text: error || FORM_ERRORS[rule]
                }
              }

              if (!errors.totalErrors) {
                errors.totalErrors = {}
              }

              errors.totalErrors[rule] = {
                key: rule,
                text: error || FORM_ERRORS[rule]
              }
            }
          })

        return errors
      }
      const getErrors = (model, parentKeys) => {
        let errors = false

        for (let key in model) {
          if (!errors) {
            errors = {}
          }

          let isEachInChild = model[key].validator && model[key].validator.$each
          let tempParentKeys = `${parentKeys}.${key !== 'nested_fields' ? key : ''}`

          const RULES_VALIDATOR = getValueFromPath({
            data: _this.$v && _this.$v.formData,
            path: tempParentKeys,
            processEach: !isEachInChild
          })

          let RULES = model[key].validator

          if (model[key].nested_fields) {
            errors[key] = getErrors(model[key].nested_fields, tempParentKeys)
          }

          if (model[key].validator) {
            errors[key] = compareRules(RULES, RULES_VALIDATOR, key)

            if (model[key].validator.$each && RULES_VALIDATOR && RULES_VALIDATOR) {
              const EACH_DATA = getValueFromPath({
                data: _this.$v && _this.$v.formData,
                path: tempParentKeys
              })
              EACH_DATA.forEach((rule, index) => {
                errors[key][index] = getErrors(model[key].validator.$each, `${tempParentKeys}.${index}`)
              })
            }
          }
        }

        return errors
      }

      return getErrors(this.formModel, '')
    },
    parentModal () {
      const getParent = (component) => {
        if (component.$options && component.$options.name && component.$options.name === 'ObModal') {
          return component
        }

        if (!component || !component.$parent) {
          return null
        } else {
          return getParent(component.$parent)
        }
      }

      return getParent(this.$parent)
    },
    isFormSubmitReady () {
      return !this.submitBtnDisabled && !this.stateReadOnly
    }
  },
  watch: {
    'parentModal.visible' (value) {
      if (value) this.resetForm()
      else this.$emit('close')
    },
    'isValid' (value) {
      this.$emit('validation', value)
    }
  },
  mounted () {
    this.$nextTick(() => {
      this.resetForm()
    })
  },
  validations () {
    let generateValidator = (model) => {
      let result = {}

      for (let key in model) {
        if (model[key].validator) {
          result[key] = {}

          Object.keys(model[key].validator).forEach((rule) => {
            result[key][rule] = model[key].validator[rule].method || model[key].validator[rule]
          })

          if (model[key].validator.$each) {
            result[key].$each = { ...generateValidator(model[key].validator.$each) }
          }
        } else if (model[key].nested_fields) {
          result[key] = generateValidator(model[key].nested_fields)
        }
      }

      return result
    }

    let validator = generateValidator(this.formModel || {})

    return {
      formData: {
        ...validator
      }
    }
  },
  methods: {
    onSubmitHandler () {
      if (this.isFormSubmitReady) {
        this.$emit('submit', { data: this.formData })
      } else {
        this.$v && this.$v.$touch()
      }
    },
    closeModal () {
      if (this.parentModal) {
        this.parentModal.close()
      } else {
        this.$emit('cancel')
      }
    },
    resetForm () {
      this.initFormData = cloneDeep(this.formData)
      this.$v && this.$v.$reset()
    },
    onKeyPressEnter () {
      this.onSubmitHandler()
    },
    cloneDeep
  }
}
</script>

<style lang="scss">
  @import "../../static/css/mixins";
  .ob-form-container {
    position: relative;
    .form-title {
      margin-bottom: 15px;
      @include font-mixin(28px, 36px, 400);
      color: $obForm-title_color;
    }
    .form-body {

    }
    .form-footer {
      margin-top: 30px;
    }
    .loading-block {
      position: absolute;
      top: 0;
      left: 0;
      z-index: 100;
      width: 100%;
      height: calc(100% + 5px);
      display: flex;
      justify-content: center;
      align-items: center;
      background-color: $obForm-loading_block_background-color;
    }

    .fadeIn-leave-to {
      opacity: 0;
    }

    .fadeIn-enter-active, .fadeIn-leave-active {
      transition: opacity .3s .2s linear;
    }
  }
</style>
